/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - April 1, 2001.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -  Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
   -  David Perry <d.perry@utoronto.ca>
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU General Public License Version 2 or later (the
   - "GPL"), in which case the provisions of the GPL are applicable
   - instead of those above.  If you wish to allow use of your
   - version of this file only under the terms of the GPL and not to
   - allow others to use your version of this file under the MPL,
   - indicate your decision by deleting the provisions above and
   - replace them with the notice and other provisions required by
   - the GPL.  If you do not delete the provisions above, a recipient
   - may use your version of this file under either the MPL or the
   - GPL.
   -
*/

////////////////////////////////////////////////////////////////////////////////
function defineShortURL(aURI)
{
  try {
    var i = aURI.indexOf(":");
  } 
  catch(ex) {
    return aURI;
  }
  if (i != -1) {
    while(!isAlphaNum(aURI[i]))
      i++;
    return aURI.substring(i, aURI.length);
  }
  return aURI;
}
////////////////////////////////////////////////////////////////////////////////
function getLocationFromClipboard()
{
  var url = null;

  try {
    var clipboard = Components.classes["@mozilla.org/widget/clipboard;1"]
                              .getService(Components.interfaces.nsIClipboard);

    var trans = Components.classes["@mozilla.org/widget/transferable;1"]
                          .createInstance(Components.interfaces.nsITransferable);

    trans.addDataFlavor("text/unicode");
    clipboard.getData(trans, clipboard.kGlobalClipboard);

    var data = {};
    var dataLen = {};
    trans.getTransferData("text/unicode", data, dataLen);

    if (data) {
      data = data.value.QueryInterface(Components.interfaces.nsISupportsString);	  
      url = data.data.substring(0, dataLen.value / 2);
    }
    else {
      alert('Sorry, Clipboard contains no data');
    }
  } catch (ex) {
    alert('Warning: Clipboard Read Error');
  }
  return url;
}
////////////////////////////////////////////////////////////////////////////////
function displayVersion()
{
  var mVersion = getBrowser().mVersion;
  var mVersionRev = getBrowser().mVersionRev;
  window.openDialog("chrome://multiviews/content/multiviewsAbout.xul", "multiviewsClose", 
                    "chrome,dialog,dependent",mVersion+mVersionRev,loadURI);
}
////////////////////////////////////////////////////////////////////////////////
function doCheck4Updates()
{
  var mVersion = getBrowser().mVersion;
  getBrowser().addTab("http://multizilla.mozdev.org/update.html?version=" + mVersion, null);
}
////////////////////////////////////////////////////////////////////////////////
function validateThisPage(aURL)
{
  if (aURL) {
    var IOService = Components.classes["@mozilla.org/network/io-service;1"]
                              .getService(Components.interfaces.nsIIOService);
    if (!IOService)
       return;
    var scheme = "";

    try {
      scheme = IOService.extractScheme(aURL, {schemeStartPos:0}, {schemeEndPos:0});
    } catch(ex) { 
      alert('error')
    }
    if (scheme == "http") {
      var checkURL = "http://validator.w3.org/check?uri=" + aURL + 
                     "&charset=%28detect+automatically%29&doctype=Inline";
      getBrowser().addTab(checkURL, null);
    }
    else 
      alert("Can't handle used protocol type "+ scheme +":\nThis validator supports http: only");
  }
}
////////////////////////////////////////////////////////////////////////////////
function getTextFromBundle(aStr) {
  var multiviewsBundle = "chrome://multiviews/locale/multiviews.properties";
  var aBundle = srGetStrBundle(multiviewsBundle);
  var aLabel = aBundle.GetStringFromName(aStr);
  return aLabel;
}
////////////////////////////////////////////////////////////////////////////////
function isAlphaNum(mixedCase) {
  var allCaps = mixedCase.toUpperCase();
  for (var i = allCaps.length - 1; i >= 0; i--) {
    var c = allCaps.charAt(i);
    if ((c < 'A' || c > 'Z') && (c < '0' || c > '9') && (c!='_'))
      return false;
  }
  return true;
}
//////////////////////////////////////////////////////////////////////////
function handlePTFolders(node)
{
  if (!node.hasChildNodes())
    return; // no folder, bail out
  var personalToolbar = node.parentNode;
  // 'hbox' for folders and 'toolbox' for the Bookmarks button 
  if (personalToolbar.nodeName == "hbox")
    personalToolbar = personalToolbar.parentNode;
  if ("lastPopup" in personalToolbar && personalToolbar.lastPopup != null) {
    node = node.firstChild;
    if (node.nodeName == "menupopup") {
      if (personalToolbar.lastPopup != null)
        personalToolbar.lastPopup.hidePopup();
      node.showPopup(node);
    }
  }
}
//////////////////////////////////////////////////////////////////////////
function checkVenkManAndInspector()
{
  var doCheck = readMyPref("multizilla.check.webtools", "bool", true);
  if (!doCheck)
    return;
  var toolsPopup = document.getElementById('toolsPopup');
  if (!toolsPopup)
    return;
  var inspector = document.getElementById('menu_inspector');
  var venkman = false;
  var items = toolsPopup.childNodes.length;
  for (var i = 0; i < items; i++) {
    if (toolsPopup.childNodes[i].getAttribute("label") == "JavaScript Debugger")
      venkman = true;
  }
  if (!venkman)
    window.InstallTrigger.install({'JavaScript Debugger Installation' : 'http://multizilla.mozdev.org/xpi/venkman.xpi'});
  if (!inspector)
    window.InstallTrigger.install({'DOM Inspector Installation' : 'http://multizilla.mozdev.org/xpi/inspector.xpi'});
  writePref("bool", "multizilla.check.webtools", false);
}
//////////////////////////////////////////////////////////////////////////
function toggleTabBarVisibility()
{
  var tabBarDisplayed = gBrowser.getStripVisibility();
  var classname = tabBarDisplayed ? "mz-toolbar-hide-button" : "mz-toolbar-show-button";
  document.getElementById("tabstrip-tbbutton").setAttribute("class", classname);
  showHideTabbar();
  var switchTabBarMenuItem = document.getElementById("switchTabBarMenuItem");
  tabBarDisplayed = gBrowser.getStripVisibility();

  if (tabBarDisplayed)
    switchTabBarMenuItem.removeAttribute("disabled");
  else 
    switchTabBarMenuItem.setAttribute("disabled", "true");
}
//////////////////////////////////////////////////////////////////////////
function initViewMenu(aMenupopup)
{
  // XXX: Total HACK to remove the original menu items
  var i = 0;
  initGoogleBoxMenuitem("GoogleBoxShowHideMenuitem");
  var removal = aMenupopup.getElementsByAttribute("observes", "cmd_viewpersonaltoolbar"); 

  if (removal.length) {
    for (i = 0; i < removal.length; i++) {
      if (!removal[i].hasAttribute("acceltext"))
        aMenupopup.removeChild(removal[i]);
    }
  }
  removal = aMenupopup.getElementsByAttribute("observes", "cmd_viewnavbar");
  if (removal.length) {
    for (i = 0; i < removal.length; i++) {
      if (!removal[i].hasAttribute("acceltext"))
        aMenupopup.removeChild(removal[i]);
    }
  }
  initToolbarsMenu();
}
//////////////////////////////////////////////////////////////////////////
function aboutGooglebox()
{
  var installed = mzToolbox.mToolboxActivated;
  var internalToolBox = document.getElementById("internalToolBox");

  if (!installed)
    gBrowser.selectedTab = gBrowser.addTab("http://multizilla.mozdev.org/features/googlebox.html");
  else
    alert(internalToolBox.mVersionInfo);
}
//////////////////////////////////////////////////////////////////////////
function initGoogleBoxMenuitem(aMenuitem)
{
  var toolboxEnabled = readMyPref("multizilla.integrated.toolbar", "bool", false);

  if (mzToolbox.mToolboxActivated && toolboxEnabled)
    document.getElementById(aMenuitem).removeAttribute("hidden");
  else
    document.getElementById(aMenuitem).setAttribute("hidden", "true");
}
//////////////////////////////////////////////////////////////////////////
function dumpHostnames()
{
  if ("links" in document.commandDispatcher.focusedWindow.document) {
    var links = document.commandDispatcher.focusedWindow.document.links;
    for (var i = 0; i < links.length; i++) {
      dump(links[i].host+' - ');
    }
    dump('\ni = '+i);
 }
}
//////////////////////////////////////////////////////////////////////////
function askToDisableButton(aEvent)
{
  aEvent.preventBubble();

  var button = aEvent.target;
  var buttonId = button.getAttribute("id");

  if (buttonId) {
    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                  .getService(Components.interfaces.nsIPromptService);

    if (promptService.confirm(window, "Disable button...", "Would you like to disable this button?")) {
      var index = buttonId.indexOf("-");
      var buttonName = buttonId.substring(0, index);
      var observerId = button.getAttribute("observes");

      if (observerId) {
         button.setAttribute("hidden", "true");
         /* var observer = document.getElementById(observerId);
         alert(observer); */
         // observer.setAttribute("disabled", true);
      }
      if (buttonId == "qpmenu-tbbutton" || buttonId == "clearlocbar-tbbutton")
        writePref("bool", "multizilla.showbutton." + buttonName, false);
      else
        writePref("bool", "browser.toolbars.showbutton." + buttonName, false);
    }
  }
}
//////////////////////////////////////////////////////////////////////////
function initButtonContextMenu(aContextMenu, aID)
{
  var buttonIDs = (aID == "NT") ? [ "skip", "skip", "back-button", "forward-button", 
                                    "reload-button", "stop-button", "skip", 
                                    "qpmenu-tbbutton", "clearlocbar-tbbutton", 
                                    "skip", "go-button", "search-button", "print-button" ] : 
                                  [ "skip", "skip", "home-button", "bookmarks-button", 
                                    "qpmenu-button" ];

  for (var i = 0; i < buttonIDs.length; i++) {
    if (buttonIDs[i] != "skip") {
      var button = document.getElementById(buttonIDs[i]);
      var hidden = button.getAttribute("hidden");
      aContextMenu.childNodes[i].setAttribute("checked", (hidden == "true") ? "false" : "true");
    }
  }
  return;
}
//////////////////////////////////////////////////////////////////////////
function doButtonUpdate(aEvent)
{
  var buttonId = aEvent.getAttribute("buttonid");
  var index = buttonId.indexOf("-");
  var buttonName = buttonId.substring(0, index);

  if (buttonId == "qpmenu-tbbutton" || buttonId == "clearlocbar-tbbutton")
    toggleBoolPref("multizilla.showbutton." + buttonName, "bool", true);
  else
    toggleBoolPref("browser.toolbars.showbutton." + buttonName, "bool", true);
}
//////////////////////////////////////////////////////////////////////////
function overrideContextMenu(aEvent)
{
  if (aEvent.button == 2) {
    var contextMenu = aEvent.target.getAttribute("context-menu");
    var overrideContextPopup = document.getElementById("buttonContextPopup");
    var defaultContextPopup = document.getElementById(contextMenu);

    if (aEvent.ctrlKey) {
      if (defaultContextPopup)
        defaultContextPopup.hidePopup();
      overrideContextPopup.showPopup(overrideContextPopup, aEvent.clientX+2, aEvent.clientY+2, "popup", "at_pointer");
    }
    else if (contextMenu) {
      defaultContextPopup.showPopup(defaultContextPopup, aEvent.clientX+2, aEvent.clientY+2, "popup", "at_pointer");
      overrideContextPopup.hidePopup();
    }
  }
}
//////////////////////////////////////////////////////////////////////////
// I wrote this small function in order to fix bug 3681 without a hastle
//////////////////////////////////////////////////////////////////////////
function getTabbrowser(node)
{
  var i = 0;
  while (node.nodeName != "tabbrowser") {
    node = node.parentNode;
    i++;
  }
  alert(i)
  return node;
}
